<?php
/*
    Axels simpler Fileviewer fuer Cronwrapper-Logs
*/
?>
<?php
$mybasedir=$_SERVER["DOCUMENT_ROOT"]."/cronlogs";

/**
  * im Cronwrapper Output den Wert eines Schlüsselwortes holen
  * @return string
  */
function parse($sData, $sKeyword){
    $sReturn='';
    $sPattern='/\n'.$sKeyword.'=(.*)/';
    preg_match_all($sPattern, $sData, $aMatches);
    if (array_key_exists("1", $aMatches)) {
        foreach ($aMatches[1] as $key=>$value) $sReturn.=$value . "\n";
    }
    return trim($sReturn);
}

// ------------------------------------------------------------
// Dateiname holen
// ------------------------------------------------------------

if (!array_key_exists("file", $_GET)){
    die("no file was detected in the url.");
}
$myfile=$_GET["file"];

if (strpos(" ".$myfile, "..")){
    echo "Sorry, the .. is not allowed.<br>";
    die();
}
if (!file_exists($mybasedir."/".$myfile) || !is_file($mybasedir."/".$myfile)) {
    echo "Sorry. File not found: $myfile<br>";
    die();
}

// ------------------------------------------------------------
// Ausgabe zusammenbauen
// ------------------------------------------------------------
$sHtml='';

$sType="text";
$sData=file_get_contents($mybasedir."/".$myfile);

$sScript=parse($sData, "SCRIPTNAME");
if ($sScript) $sType="cronlog";

switch ($sType) {
    case "cronlog":
        $rc=parse($sData, "SCRIPTRC");        
        $iExpire=parse($sData, "JOBEXPIRE");


        $sClassRc='error'; if ($rc==0) $sClassRc='ok';
        $sClassExp='error'; if ($iExpire>date("U")) $sClassExp='ok';

        if ($rc==0 && $iExpire>date("U")) {
            $sHtml.='<div class="ok">Cronjob ist OK.';
        } else {
            $sHtml.='<div class="error">Fehler gefunden.';
            $sHtml.='&nbsp;&nbsp;&nbsp;<span class="'.$sClassRc.'">returncode: '.$rc.'</span>';
        }
        $sHtml.='&nbsp;&nbsp;&nbsp;<span class="'.$sClassExp.'">expire: '.date("Y-m-d H:i:s", $iExpire).'</span>';
        $sHtml.='</div>';
        $sData=preg_replace('/([A-Z]*=)(.*)/', '<span class="key">$1</span><span class="value">$2</span>', $sData);
        $sData=preg_replace('/(JOBEXPIRE=.*)/', '<span class="'.$sClassExp.'">$1</span>', $sData);
        $sData=preg_replace('/(SCRIPTRC=.*)/', '<span class="'.$sClassRc.'">$1</span>', $sData);

        // moegliche returncodes im scriptout Block einfaerben
        $sData=preg_replace('/(rc=[1-9][0-9]*)/', '<span class="error">$1</span>', $sData);
        $sData=preg_replace('/(rc=[1-9])/', '<span class="error">$1</span>', $sData);
        // $sData=preg_replace('/(rc=0)/', '<span class="ok">$1</span>', $sData);

        // remove terminal color
        $sData=preg_replace('/(\[[0-9]{1,3}m)/', '', $sData);

        $sData='<div class="cronlog">'.$sData.'</div>';
        break;
    default:
       echo ""; 
}
// ------------------------------------------------------------
// Ausgabe
// ------------------------------------------------------------

echo "<!doctype html>
<html><head>
    <title>$myfile</title>
    <style>
        .ok{background: #afa;}
        .error{background: #faa;}
        .cronlog{color:#aaa; font-style: italic;}
        .key{color:#11a; font-style: normal;}
        .value{color:#000; font-style: normal;}
        a.button{
            padding: 3px; border: 3px solid #fff; box-shadow: 0 0 7px #ccc;
            background: #eee; background: linear-gradient(#ddd, #fff, #ccc);
            border-radius: 5px; text-decoration: none; color: #555; 
        }
        a.button:hover{background: #ddf; box-shadow: 0 0 2px #ddd; }
        body{font-family: arial; background:#fff; color:#333;}
        pre{background: #eee; color:#666; margin: 0;}
    </style>
</head>
<body>
    <a href='#' onclick='javascript:history.back();' class='button'>zur&uuml;ck</a>
    <a href='cronjobs.html' class='button'>&uuml;bersicht der Cronjobs</a>
    File: $myfile<br>
    <br>
    $sHtml
    <pre>$sData</pre>

</body></html>
";

